From b0662b04f49e1048a90ba7cecd2fe8e003d6b581 Mon Sep 17 00:00:00 2001
From: Ismael Luceno <ismael@iodev.co.uk>
Date: Sun, 19 Feb 2023 16:16:36 +0100
Subject: [PATCH 2/3] Fix off-by-one string copies

Upstream-Status: Pending
Signed-off-by: Ismael Luceno <ismael@sourcemage.org>
---
 src/debugger.c | 7 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

diff --git a/src/debugger.c b/src/debugger.c
index 3b8a1f5845cc..51d7ea90bcfb 100644
--- a/src/debugger.c
+++ b/src/debugger.c
@@ -1759,9 +1759,9 @@ debug ()
               cl = (char *) 0;
             }
 	  if (old_line)
-	    cl = strcpy ((char *) malloc (strlen (old_line)), old_line);
+	    cl = strdup(old_line);
 	  else
-	    cl = strcpy ((char *) malloc (strlen ("(null)")), "(null)");
+	    cl = strdup("(null)");
 	}
       else
 	{
@@ -1779,8 +1779,8 @@ debug ()
 	      free (old_line);
               old_line = (char *) 0;
 	    }
-	  cl = strcpy ((char *) malloc (strlen (rl)), rl);
-	  old_line = strcpy ((char *) malloc (strlen (rl)), rl);
+	  cl = strdup(rl);
+	  old_line = strdup(rl);
 #ifdef HAVE_READLINE
 	  add_history (rl);
 #endif
-- 
2.39.1

